import { CalcBtn } from './CalcBtn';

export const STD_KEYBOARD: CalcBtn[] = [
  { txt: 'sin', fn: (s) => { return s + 'sin(' }, ids: ['sin'], isOp: true },
  { txt: 'cos', fn: (s) => { return s + 'cos(' }, ids: ['cos'], isOp: true },
  { txt: 'tan', fn: (s) => { return s + 'tan(' }, ids: ['tan'], isOp: true },
  { txt: 'x<sup>n</sup>', fn: (s) => { return s + '^' }, ids: ['Dead'] },
  { txt: '&#8730;x', fn: (s) => { return s + '^(0.5)' }, ids: ['square root'] },
  { txt: '7', fn: (s) => { return s + '7' }, ids: ['7'] },
  { txt: '8', fn: (s) => { return s + '8' }, ids: ['8'] },
  { txt: '9', fn: (s) => { return s + '9' }, ids: ['9'] },
  { txt: 'DEL', fn: (s) => { return s.substring(0, s.length - 1) }, ids: ['Delete', 'Backspace'] },
  { txt: 'C', fn: (s) => { return '' }, ids: ['='] },
  { txt: '4', fn: (s) => { return s + '4' }, ids: ['4'] },
  { txt: '5', fn: (s) => { return s + '5' }, ids: ['5'] },
  { txt: '6', fn: (s) => { return s + '6' }, ids: ['6'] },
  { txt: 'x', fn: (s) => { return s + '*' }, ids: ['x'] },
  { txt: '÷', fn: (s) => { return s + '/' }, ids: ['/'] },
  { txt: '1', fn: (s) => { return s + '1' }, ids: ['1'] },
  { txt: '2', fn: (s) => { return s + '2' }, ids: ['2'] },
  { txt: '3', fn: (s) => { return s + '3' }, ids: ['3'] },
  { txt: '+', fn: (s) => { return s + '+' }, ids: ['+'] },
  { txt: '-', fn: (s) => { return s + '-' }, ids: ['-'] },
  { txt: '0', fn: (s) => { return s + '0' }, ids: ['0'] },
  { txt: '.', fn: (s) => { return s + '.' }, ids: ['.'] },
  { txt: '(', fn: (s) => { return s + '(' }, ids: ['('] },
  { txt: ')', fn: (s) => { return s + ')' }, ids: [')'] },
  { txt: '%', fn: (s) => { return s + '%' }, ids: ['%'] }
];

export const EXTENDED_KEYBOARD: CalcBtn[] = [
  { txt: 'sin', fn: (s) => { return s + 'sin(' }, ids: ['sin'], isOp: true },
  { txt: 'cos', fn: (s) => { return s + 'cos(' }, ids: ['cos'], isOp: true },
  { txt: 'tan', fn: (s) => { return s + 'tan(' }, ids: ['tan'], isOp: true },
  { txt: 'asin', fn: (s) => { return s + 'asin(' }, ids: ['asin'], isOp: true },
  { txt: 'acos', fn: (s) => { return s + 'acos(' }, ids: ['acos'], isOp: true },
  { txt: 'atan', fn: (s) => { return s + 'atan(' }, ids: ['atan'], isOp: true },

  { txt: 'sinh', fn: (s) => { return s + 'sinh(' }, ids: ['sinh'], isOp: true },
  { txt: 'cosh', fn: (s) => { return s + 'cosh(' }, ids: ['cosh'], isOp: true },
  { txt: 'tanh', fn: (s) => { return s + 'tanh(' }, ids: ['tanh'], isOp: true },
  { txt: 'log', fn: (s) => { return s + 'log(' }, ids: ['log'], isOp: true },
  { txt: 'log2', fn: (s) => { return s + 'log2(' }, ids: ['log2'], isOp: true },
  { txt: 'log10', fn: (s) => { return s + 'log10(' }, ids: ['log10'], isOp: true },

  { txt: 'DEL', fn: (s) => { return s.substring(0, s.length - 1) }, ids: ['Delete', 'Backspace'] },
  { txt: '7', fn: (s) => { return s + '7' }, ids: ['7'] },
  { txt: '8', fn: (s) => { return s + '8' }, ids: ['8'] },
  { txt: '9', fn: (s) => { return s + '9' }, ids: ['9'] },
  { txt: '&#8730;x', fn: (s) => { return s + '^(0.5)' }, ids: ['square root'] },
  { txt: 'x<sup>n</sup>', fn: (s) => { return s + '^' }, ids: ['Dead'] },
  { txt: 'C', fn: (s) => { return '' }, ids: ['='] },
  { txt: '4', fn: (s) => { return s + '4' }, ids: ['4'] },
  { txt: '5', fn: (s) => { return s + '5' }, ids: ['5'] },
  { txt: '6', fn: (s) => { return s + '6' }, ids: ['6'] },
  { txt: 'x', fn: (s) => { return s + '*' }, ids: ['x'] },
  { txt: '÷', fn: (s) => { return s + '/' }, ids: ['/'] },

  { txt: '%', fn: (s) => { return s + '%' }, ids: ['%'] },
  { txt: '1', fn: (s) => { return s + '1' }, ids: ['1'] },
  { txt: '2', fn: (s) => { return s + '2' }, ids: ['2'] },
  { txt: '3', fn: (s) => { return s + '3' }, ids: ['3'] },
  { txt: '-', fn: (s) => { return s + '-' }, ids: ['-'] },
  { txt: '+', fn: (s) => { return s + '+' }, ids: ['+'] },

  { txt: '(', fn: (s) => { return s + '(' }, ids: ['('] },
  { txt: ')', fn: (s) => { return s + ')' }, ids: [')'] },
  { txt: '0', fn: (s) => { return s + '0' }, ids: ['0'] },
  { txt: '.', fn: (s) => { return s + '.' }, ids: ['.'] },
  { txt: '!', fn: (s) => { return s + 'factorial(' }, ids: ['!'], isOp: true },
];

export const PROGRAMMER_KEYBOARD: CalcBtn[] = [
  { txt: 'and', fn: (s) => { return s + 'bitAnd(' }, ids: ['and'], isOp: true },
  { txt: 'D', fn: (s) => { return s + 'D' }, ids: ['D'] },
  { txt: 'E', fn: (s) => { return s + 'E' }, ids: ['E'] },
  { txt: 'F', fn: (s) => { return s + 'F' }, ids: ['F'] },
  { txt: 'not', fn: (s) => { return s + 'bitNot(' }, ids: ['bitNot'], isOp: true },
  { txt: 'xor', fn: (s) => { return s + 'bitXor(' }, ids: ['xor'], isOp: true },

  { txt: 'or', fn: (s) => { return s + 'bitOr(' }, ids: ['or'], isOp: true },
  { txt: 'A', fn: (s) => { return s + 'A' }, ids: ['A'] },
  { txt: 'B', fn: (s) => { return s + 'B' }, ids: ['B'] },
  { txt: 'C', fn: (s) => { return s + 'C' }, ids: ['C'] },
  { txt: 'log2', fn: (s) => { return s + 'log2(' }, ids: ['log2'], isOp: true },
  { txt: 'log10', fn: (s) => { return s + 'log10(' }, ids: ['log10'], isOp: true },

  { txt: 'DEL', fn: (s) => { return s.substring(0, s.length - 1) }, ids: ['Delete', 'Backspace'] },
  { txt: '7', fn: (s) => { return s + '7' }, ids: ['7'] },
  { txt: '8', fn: (s) => { return s + '8' }, ids: ['8'] },
  { txt: '9', fn: (s) => { return s + '9' }, ids: ['9'] },
  { txt: '&#8730;x', fn: (s) => { return s + '^(0.5)' }, ids: ['square root'] },
  { txt: 'x<sup>n</sup>', fn: (s) => { return s + '^' }, ids: ['Dead'] },
  { txt: 'C', fn: (s) => { return '' }, ids: ['='] },
  { txt: '4', fn: (s) => { return s + '4' }, ids: ['4'] },
  { txt: '5', fn: (s) => { return s + '5' }, ids: ['5'] },
  { txt: '6', fn: (s) => { return s + '6' }, ids: ['6'] },
  { txt: 'x', fn: (s) => { return s + '*' }, ids: ['x'] },
  { txt: '÷', fn: (s) => { return s + '/' }, ids: ['/'] },

  { txt: '%', fn: (s) => { return s + '%' }, ids: ['%'] },
  { txt: '1', fn: (s) => { return s + '1' }, ids: ['1'] },
  { txt: '2', fn: (s) => { return s + '2' }, ids: ['2'] },
  { txt: '3', fn: (s) => { return s + '3' }, ids: ['3'] },
  { txt: '-', fn: (s) => { return s + '-' }, ids: ['-'] },
  { txt: '+', fn: (s) => { return s + '+' }, ids: ['+'] },

  { txt: '(', fn: (s) => { return s + '(' }, ids: ['('] },
  { txt: ')', fn: (s) => { return s + ')' }, ids: [')'] },
  { txt: '0', fn: (s) => { return s + '0' }, ids: ['0'] },
  { txt: '.', fn: (s) => { return s + '.' }, ids: ['.'] },
];

export const DATETIME_KEYBOARD: CalcBtn[] = [
  { txt: 'year', fn: (s) => { return s + ' year' }, ids: ['year'], isOp: true },
  { txt: 'month', fn: (s) => { return s + ' month' }, ids: ['month'], isOp: true },
  { txt: 'day', fn: (s) => { return s + ' day' }, ids: ['day'], isOp: true },
  { txt: 'hour', fn: (s) => { return s + ' hour' }, ids: ['hour'], isOp: true },
  { txt: 'second', fn: (s) => { return s + ' second' }, ids: ['second'], isOp: true },
  
  { txt: '7', fn: (s) => { return s + '7' }, ids: ['7'] },
  { txt: '8', fn: (s) => { return s + '8' }, ids: ['8'] },
  { txt: '9', fn: (s) => { return s + '9' }, ids: ['9'] },
  { txt: 'x<sup>n</sup>', fn: (s) => { return s + '^' }, ids: ['Dead'] },
  { txt: 'ms', fn: (s) => { return s + ' ms' }, ids: ['millisecond'], isOp: true },

  { txt: '4', fn: (s) => { return s + '4' }, ids: ['4'] },
  { txt: '5', fn: (s) => { return s + '5' }, ids: ['5'] },
  { txt: '6', fn: (s) => { return s + '6' }, ids: ['6'] },
  { txt: 'x', fn: (s) => { return s + '*' }, ids: ['x'] },
  { txt: '÷', fn: (s) => { return s + '/' }, ids: ['/'] },

  { txt: '1', fn: (s) => { return s + '1' }, ids: ['1'] },
  { txt: '2', fn: (s) => { return s + '2' }, ids: ['2'] },
  { txt: '3', fn: (s) => { return s + '3' }, ids: ['3'] },
  { txt: '-', fn: (s) => { return s + '-' }, ids: ['-'] },
  { txt: '+', fn: (s) => { return s + '+' }, ids: ['+'] },

  { txt: '0', fn: (s) => { return s + '0' }, ids: ['0'] },
  { txt: '(', fn: (s) => { return s + '(' }, ids: ['('] },
  { txt: ')', fn: (s) => { return s + ')' }, ids: [')'] },
  { txt: '.', fn: (s) => { return s + '.' }, ids: ['.'] },
  { txt: 'DEL', fn: (s) => { return s.substring(0, s.length - 1) }, ids: ['Delete', 'Backspace'] },

];